package cn.com.qmth.stmms.biz.basic.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.stmms.biz.basic.dao.PrivilegeDao;
import cn.com.qmth.stmms.biz.basic.model.Privilege;
import cn.com.qmth.stmms.biz.basic.service.PrivilegeService;
import cn.com.qmth.stmms.biz.common.BaseQueryService;
import cn.com.qmth.stmms.common.enums.PrivilegeType;

@Service("privilegeService")
public class PrivilegeServiceImpl extends BaseQueryService<Privilege> implements PrivilegeService {
	private static List<Privilege> privileges = null;
	private static Object lock = new Object();
	@Autowired
	private PrivilegeDao privilegeDao;

	@Override
	public List<Privilege> getMenuPrivileges() {
		if (privileges == null) {
			synchronized (lock) {
				if (privileges == null) {
					privileges = privilegeDao.findByPrivilegeTypeOrderByLevelAscSeqAsc(PrivilegeType.MENU);
					if (privileges == null) {
						privileges = new ArrayList<>();
					}
				}
			}
		}
		return privileges;
	}
}
